/***********************************************************
daum(hanmail)
***********************************************************/
var hostString="";
var supportInboxOnly=true;
var supportShowFolders=true;
var keepLogin=true;
function init(){
  this.loginData=["https://logins.daum.net/accounts/login.do",
                      "id","pw","stln=on"];
  this.dataURL="http://mail2.daum.net/hanmailex/Top.daum";
  this.viewURL="http://mail2.daum.net/hanmailex/Top.daum";
  this.viewDomain="mail.*?.daum.net";

  this.cookieDomain="daum.net";

  this.logoutURL="https://logins.daum.net/accounts/logout.do";
}
function checkLogin(aData,aHttp){
  switch(this.stage){
  case ST_CHECK:
    this.getHtml(this.dataURL);
    return false;
  case ST_CHECK+1:
    var fnd=aData.match(/<div\s+id="daumLogin"/);
    if(!fnd){//logged in already
      this.stage=ST_DATA;
      return this.process(aData,aHttp);
    }else{
      this.cookieManager.clear();
      this.stage=this.initStage;
      return this.process("");
    }
  }
  this.onError();
  return true;
}
function process(aData,aHttp){
  switch(this.stage){
  case ST_DATA:
    this.stage=ST_DATA_RES+1;
    this.getHtml("https://logins.daum.net/accounts/auth.gif");//set cookies
    return true;
  case ST_DATA_RES+1:
    this.stage=ST_DATA_RES;
    this.getHtml(this.dataURL);
    return true;
  }
  return this.baseProcess(aData,aHttp);
}

function getData(aData){
  var obj={}
  var fnd=aData.match(/folderList:\[([\s\S]+?)\]/);
  if(fnd){
    var ar=[];
    var num=0;
    var re=/{.+?\'name\':\"(.+?)\".+?\'newCount'\:(\d+)/g;
    var o;
    while ((o = re.exec(fnd[1])) != null){
      if(o[1]=="\\uBCF4\\uB0B8\\uD3B8\\uC9C0\\uD568")continue;
      if(o[1]=="\\uC784\\uC2DC\\uBCF4\\uAD00\\uD568")continue;
      if(o[1]=="\\uC2A4\\uD338\\uD3B8\\uC9C0\\uD568")continue;
      if(o[1]=="\\uD734\\uC9C0\\uD1B5")continue;
      if(o[1]==":\\uC218\\uC2E0\\uD655\\uC778:")continue;
      if(o[1]==":UNREAD:")continue;
      var n=0
      if(o[2])n=parseInt(o[2]);
      if(this.inboxOnly){
        if(o[1]=="\\uBC1B\\uC740\\uD3B8\\uC9C0\\uD568")num=n;
      }else num+=n;
      if(n>0&&o[1]!="\\uBC1B\\uC740\\uD3B8\\uC9C0\\uD568"){
        var name=unescape(o[1].replace(/\\/g,"%"));
        ar.push({id:name,count:n});
      }
    }
    this.count=num;
    if(this.showFolders){
      if(ar)obj.folders=ar;
    }
    return obj;
  }else{
    this.count=-1;
    return obj;
  }
}
function getViewURL(aFolder){
  if(aFolder){
    return "http://mail.daum.net/hanmail/Index.daum?COMMAND=list&FOLDER="+encodeURIComponent(aFolder);
  }
  return this.viewURL;
}