/***********************************************************
Live(Hotmail)
***********************************************************/
var hostString="hotmail.com";
var supportInboxOnly=true;
var supportShowFolders=true;
var supportIncludeSpam=true;

function init(){
  this.initStage=ST_PRE;
  this.loginData=["","login","passwd","KMSI=1&LoginOptions=1"];
  this.dataURL="http://mail.live.com/default.aspx?rru=inbox";
  this.viewURL="http://mail.live.com/default.aspx?rru=inbox";
  this.viewDomain="mail.live.com";
  if(this.password.length>16)this.password=this.password.substring(0,16);
}
function getIconURL(){
  return "http://gfx1.hotmail.com/mail/w5/m4/ltr/OLFav.ico";
}
function checkLogin(aData,aHttp){
  switch(this.stage){
  case ST_CHECK:
    this.getHtml(this.viewURL);
    return false;
  case ST_CHECK+1:
    var fnd=aData.match(/urlPost:/);
    var fnd2=aData.match(/sFT:'(\S+?)'/);
    if(!fnd||fnd2){//logged in
      this.stage=ST_LOGIN_RES;
      return this.process(aData,aHttp);
    }else{
      this.cookieManager.clear();
      try{
        var s=this.main.prefBranch.getCharPref("accounts.["+this.id+"#"+this.user+"].cookie");
        s=s.split("\t");
        this.cookieManager.addCookies(s[0],s[1]);
      }catch(e){}
      this.stage=this.initStage;
      return this.process("");
    }
  }
  this.onError();
  return true;
}
function process(aData,aHttp) {
//dlog(this.user+" "+this.stage+" "+aData);
if(this.debug)dlog(this.id+"\t"+this.user+"\t"+this.stage,aData);
  switch(this.stage){
  case ST_PRE:
    this.getHtml("http://mail.live.com");
    return false;
  case ST_PRE_RES:
    var fnd=aData.match(/urlPost:\'([\s\S]+?)\'/);
    if(fnd){
      this.loginData[LOGIN_URL]=fnd[1];
      fnd=aData.match(/PPFT[\s\S]+?value=\"(\S+?)\"/);
      if(fnd){
        this.stage=ST_LOGIN;
        this.getHtml(this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]+"&PPFT="+encodeURIComponent(fnd[1]));
        return false;
      }
    }
    this.onError();
    return true;
  case ST_LOGIN_RES:
    var fnd=aData.match(/sFT:'(\S+?)'/);
    if(fnd){//2-step verification
      var fnd2=aData.match(/urlPost:'(\S+?)'/);
      var fnd3=aData.match(/data:'([^}]+?)',type:([^}]+?),[^}]+?otcSent:([^,]+?),[^}]+?isSADef:true,isVoiceDef:(\S+?)}/);
      if(fnd2&&fnd3){
        this.form=[fnd2[1],
                  "login="+encodeURIComponent(this.user)+"&type="+(fnd3[2]=="10"?19:18)
                  +"&PPFT="+encodeURIComponent(fnd[1])
                  +"&SentProofID="+encodeURIComponent(fnd3[1])];
        if(fnd3[2]=="10"||fnd3[3]=="true"){
          this.stage=(ST_LOGIN_RES+5);
          this.openAuthDialog(this.id,this.user,null);
          return true;
        }else{
          var fnd4=aData.match(/<base href="(\S+?)"/);
          if(fnd4){
            var type={SQSA: 6, CSS: 5, DeviceId: 4, Email: 1, AltEmail: 2, SMS: 3, HIP: 8, Birthday: 9, TOTPAuthenticator: 10, Voice: -3};
            var t=parseInt(fnd3[2]);
            if(fnd3[4]=="true")t=-t;
            var chn;
            for(var i in type){
              if(type[i]==t){
                chn=i;
                break;
              }
            }
            if(!chn)break;
            var dtype=null;
            switch(t){
            case type.Voice:
            case type.SMS:
              dtype="MobileNum";
              break;
            case type.Email:
            case type.AltEmail:
              dtype="AltEmail";
              break;
            }
            this.stage=(ST_LOGIN_RES+4);
            this.getHtml(fnd4[1]+"GetOneTimeCode.srf",
                        "login="+encodeURIComponent(this.user)+"&flowtoken="+encodeURIComponent(fnd[1])+"&purpose=eOTT_OneTimePassword&channel="+chn
                        +(dtype?"&"+dtype+"="+encodeURIComponent(fnd3[1]):"")+"&UIMode=11");
            return true;
          }
        }
      }
      this.onError();
      return true;
    }
    var fnd=aData.match(/<form.+?action="(.+?)"/);
    if(fnd){//@hotmail.com, @live.nl
      this.getHtml(this.viewURL);
      return false;
    }
    ++this.stage;
  case ST_LOGIN_RES+1:
    var fnd=aData.match(/window.location.replace\([\'\"](\S+?)[\'\"]/);
    if(fnd){//login expired
      this.getHtml(fnd[1]);
      return false;
    }
    ++this.stage;
  case ST_LOGIN_RES+2:
    var fnd=aData.match(/"afu":"(\S+?InboxLight.aspx\S+?)"/);
    if(fnd){
      fnd=unescape(fnd[1].replace(/\\u/g,"%u"));
      this.dataURL=fnd;
      var url=this.dataURL.match(/(((\S+):\/\/([^/]+))(\S*\/)?)([^/]*)/);
      if(url)this.mailHost=url[2];
      this.stage=ST_DATA_RES;
    }else{
      fnd=aData.match(/BrowserSupport.aspx[\s\S]+?BrowserSupport.aspx[\s\S]+?(BrowserSupport.aspx\S+?)"/);
      if(fnd){
        var fnd2=aData.match(/"HotmailDomain":"(\S+?)"/);
        if(fnd2){
          fnd2=unescape(fnd2[1].replace(/\\u/g,"%u"));
          this.mailHost=fnd2;
          this.stage=ST_DATA_RES;
          this.getHtml(this.mailHost);
          return true;
        }
      }
      fnd=aData.match(/href="(\S+?InboxLight.aspx\S+?)">/);
      if(fnd){//Thunderbird(browser check)
        fnd=fnd[1].replace(/&#(\d+);/g,function(){return String.fromCharCode(RegExp.$1);});
        this.stage=ST_LOGIN_RES+3;
        this.getHtml(fnd);
        return true;
      }
    }
    break;
  case ST_LOGIN_RES+3:
    var fnd=aData.match(/<base\s+href="(\S+?)"/);
    if(fnd){
      var url=fnd[1].match(/(((\S+):\/\/([^/]+))(\S*\/)?)([^/]*)/);
      if(url)this.mailHost=url[2];
    }
    this.stage=ST_DATA_RES;
    break;
  case (ST_LOGIN_RES+4)://2-step verification
    if(aData.match(/"State":201/)){
      this.stage=(ST_LOGIN_RES+5);
      this.openAuthDialog(this.id,this.user,null);
      return true;
    }
    break;
  case (ST_LOGIN_RES+5)://2-step verification
    if(aData){
      this.getHtml(this.form[0],"otc="+encodeURIComponent(aData)+"&AddFD=1&"+this.form[1]);
      delete this.form;
      return false;
    }
    break;
  case (ST_LOGIN_RES+6)://2-step verification
    this.stage=ST_LOGIN_RES;
    var ck=this.cookieManager.findCookieString("login.live.com","SDIDC");
    if(ck){
      this.main.prefBranch.setCharPref("accounts.["+this.id+"#"+this.user+"].cookie",aHttp.URI.spec+"\t"+ck);
    }
    return this.process(aData,aHttp);
  }
  return this.baseProcess(aData,aHttp);
}
function getData(aData){
  var obj={};
  var ar=[];
  var fnd=aData.match(/<ul.+?class="List FolderList.+?>([\s\S]+?)<\/ul>/g);
  if(fnd){
    fnd=fnd.toString();
    var re=/<li.+?\s+id="(.+?([^-]+?))"\s+nm="(.+?)"\s+count="(\d+)"/g;
    var o;
    this.count=0;
    while ((o = re.exec(fnd)) != null){
      if(o[2]=="000000000004"
        ||o[2]=="000000000003"||o[2]=="000000000002")continue;
      if(!this.includeSpam&&o[2]=="000000000005")continue;
      var n=parseInt(o[4]);
      if(o[2]=="000000000005"){
        if(this.includeSpam==2)this.count+=n;
      }else if(this.inboxOnly){
        if(o[2]=="000000000001")this.count+=n;
      }else this.count+=n;
      if(n>0&&o[2]!="000000000001"){
        var name=o[3];
        name=name.replace(/&#(\d+);/g,function(){return String.fromCharCode(RegExp.$1);});
        ar.push({id:o[1].replace(/-/g,""),title:name,count:n});
      }
    }
    if(this.showFolders){
      if(ar)obj.folders=ar;
    }
    return obj;
  }
  this.count=-1;
  return obj;
}
function getViewURL(aFolder){
  if(aFolder&&this.mailHost){
    var url=this.mailHost+"/mail/InboxLight.aspx?fid="+aFolder
              +"&n="+parseInt(Math.random()*1000000000);
    return url;
  }
  return this.viewURL;
}
